// To create dynamic library .so file command is R CMD SHLIB famQBL.c 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "R.h"
#include <Rmath.h>

#define SIZE 1000
int iter;
double be[12] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0}, fr = 0.0, d_val = 0.0;

struct family {
  int **id, *fam_id, *fid, *mid, num_hap_config,*founder,*gender,*index,non_founder,rows,num_memb;
  int  **hap_conf,**z_update,**child,**spouse,*spouse_count;
  double **tran_prob,*polygenic,*y,*mu;
};


void trans_prob_calc(struct family fam,int hap_config,int fam_mem);
double update_sigma_sqA(int N,double a0,double s0 ,double poly[],double **sigma_inv);
void update_Z(int num_hap, struct family fam, double beta[], double sigma_sqE, double D, double freq[], int num_memb, int num_hap_config, int max_hap_index);
double update_sigma_sqE(struct family fam[],int N,int num_fam,double e0,double t0);
void update_beta(double sigma_sqE,struct family fam[],double beta[],double lambda,int num_fam,int num_hap, int max_hap_index,int it,int burn_in);
double update_lambda(double beta[], double a, double b, int num_hap);
void update_Uij(double sigma_sqE,double sigma_sqA,struct family fam[],double beta[],int num_fam, int max_hap_index);
void update_Uj_block(double y[], double Uj[], double MUj[], double **sigma_inv, double sigma_sqE, int nj);
void update_freq(double freq[], double D, struct family fam[], int h, int num_family,int it,int burn_in);
double update_D(double freq[], double D, int h, struct family fam[],int num_family,int it,int burn_in);
double gen_double_exp(double mean, double SD);
void dirichlet(double *param, int dim, double *gen_sample);
void mat_inv(double **mat,double **mat_inv,int n);
void mat_vec_mult(double **mat, double vec[], double out[], int n);
void dealloc2D(double **mat,int n);
double determinant(double **a,int k);
double find_max_ratio(double arr[], int n);
int max_freq_index(double freq[],int h);
double find_min(double arr[], int n);
double sum(double *x, int n);
void sort(double freq_sort[],int h);
int match(char [], char []);


void setgmn ( float meanv[], float covm[], int p, float parm[] );
float *genmn ( float parm[] );
int spofa ( float a[], int lda, int n );
float sdot ( int n, float dx[], int incx, float dy[], int incy );
float snorm ( );
float r4_uni_01 ( );
int initialized_get ( );
void initialize ( );
int i4_uni ( );
void initialized_memory ( int i, int *initialized );
void initialized_set ( );
int cgn_get ( );
void cgn_memory ( int i, int *g );
void cgn_set ( int g );
void cg_get ( int g, int *cg1, int *cg2 );
void cg_memory ( int i, int g, int *cg1, int *cg2 );
void cg_set ( int g, int cg1, int cg2 );
int antithetic_get ( );
void antithetic_memory ( int i, int *value );
void antithetic_set ( int value );
void set_initial_seed ( int ig1, int ig2 );
void ig_get ( int g, int *ig1, int *ig2 );
void ig_memory ( int i, int g, int *ig1, int *ig2 );
void ig_set ( int g, int ig1, int ig2 );
void init_generator ( int t );
void lg_get ( int g, int *lg1, int *lg2 );
void lg_memory ( int i, int g, int *lg1, int *lg2 );
void lg_set ( int g, int lg1, int lg2 );
int multmod ( int a, int s, int m );


int mcmc(char **file1, char **file2, double *poly,double *kin_inv, int *N, double *start_beta, int *num_fam, double *y, double *mean_trait_founder, double *var_trait_founder, double *mean_trait_founder_baseline, int *num_it, int *burn_in, double *beta_out, double *freq_out, double *lambda_out, double *D_out, double *ssA_out, double *ssE_out)
{
  FILE *fp1,*fp2,*fp3,*fp4,*fp5,*fp6,*fp7,*fp8,*in;
  struct family FAM[*num_fam];
  char str[SIZE],c,str1[20];
  int i,j,k,l,h,n,m,it1=0,it2=0,len,sum,col1,col2,counter = 0,flag=0,val,num_snps,**pedigree,*fam,*hap_config,*founders,*non_founders,*hap_map,max_hap_index,**configID;
  double **sigma_inv, **sig_inv, **sig_inv1, *beta, *freq, *freq_sort, temp, D=0, BETA_START, sigma_sqA=1.0,sigma_sqE=1.0,lambda=1.0,a0=4.0,s0=2.0,e0=4.0,t0=2.0,a=20.0,b=20.0;
  
  sigma_inv = calloc(*N,sizeof(double *));
  
  for(i=0;i<*N;i++)
    sigma_inv[i] = calloc(*N,sizeof(double));
  
  k = 0;
  for(i=0; i<*N; i++)
  {
      for(j=0; j<*N; j++)
	{
	  sigma_inv[i][j] = kin_inv[k++];
	}
  }

  // opening input file for sample size, num families and storing pedigree information 

  in = fopen(*file1,"r");
  //ped = fopen("out_files_fam/pedigree.txt","w");
  if(in == NULL) {
      perror("Error opening input data set file");
      return(-1);
   }

  //inputing sample size and number of SNPS
  fscanf(in,"%d %d",&n,&num_snps);
  pedigree = calloc(*N,sizeof(int*));
  for(i=0;i<*N;i++)
    pedigree[i] = calloc(5,sizeof(int));

  //reading in pedigree:Fam ID, indiv ID, father ID, mother ID, Gender, Association
  for(i=0;i<*N;i++)
  {
	  fscanf(in,"%d %d %d %d %d",&pedigree[i][0],&pedigree[i][1],&pedigree[i][2],&pedigree[i][3],&pedigree[i][4]);
      fgets(str,sizeof str,in);
  }
  
  fp1 = fopen(*file2,"r");
  fp2 = fopen("extracted_fam_qbl100.txt","w");
  if(fp1 == NULL) 
    {
      perror("Error opening haplore output file");
      return(-1);
    }
   while( fgets (str,sizeof str, fp1)!=NULL ) 
     {
       str[strlen(str)-1]='\0';
       if(strcmp(str,"All compatible haplotype configurations are:")==0)
	 {
	   fgets (str,sizeof str, fp1);
	   flag = 1;
	   continue;
	 }
       if(strcmp(str,"## The following results list the haplotype configuration with the maximum probability in each family")==0) 
	 {
	   flag = 0;
	   continue;
	 }
       if(flag==1) 
	 {
	   fprintf(fp2,"%s\n",str);
	   fflush(fp2);
	   }
   }
   
   fclose(fp1);
   fclose(fp2);
   fp1 = fopen("extracted_fam_qbl100.txt","r");
   fp3 = fopen("num_hap_config.txt","w");
   fp4 = fopen("num_members.txt","w");
   fp5 = fopen("founders.txt","w");
   fp6 = fopen("non-founders.txt","w");
   fp7 = fopen("hap-freq.txt","w");
   fp8 = fopen("configID.txt","w");

   while(fgets (str,sizeof str, fp1)!=NULL) {
      // writing content to stdout 
     str[strlen(str)-1]='\0';
     i = match(str,"The number of haplotype configurations in this family is:");
     if(i!=-1){
       // writing haplotype configurations to file
       fprintf(fp3,"%s\n",str);
       fflush(fp3);
       continue;
     }
     i = match(str,"The number of individuals in this family is:");
     if(i!=-1){
       // writing number of family members of each family to file
       fprintf(fp4,"%s\n",str);
       fflush(fp4);
       continue;
     }
     i = match(str,"The number of founders in this family is:");
     if(i!=-1){
       // writing number of founders of each family to file
       fprintf(fp5,"%s\n",str);
       fflush(fp5);
       continue;
     }
     i = match(str,"The number of non-founders in this family is:");
     if(i!=-1){
       // writing number of non-founders of each family to file
       fprintf(fp6,"%s\n",str);
       fflush(fp6);
       continue;
     }
     i = match(str,"The total of ");
     if(i!=-1){
        sscanf(str,"%s %s %s %d %s %s",str1,str1,str1,&h,str1,str1); // line added after stuck in setting 3, handle > 9 haplotypes
       // retrieving and storing haplotype frequencies 
       for(j=0;j<h;j++){
	 fgets(str,sizeof str,fp1);
	 fprintf(fp7,"%s",str);
	 fflush(fp7);
       }
     }
     i = match(str,"ConfigID");
     if(i!=-1){
       // Writing the order in which the haplotype pair are listed
       fprintf(fp8,"%s\n",str);
       fflush(fp8);
       continue;
     }
   }// while.. 
   
   fclose(fp1);
   fclose(fp3);
   fclose(fp4);
   fclose(fp5);
   fclose(fp6);
   fclose(fp7);
   fclose(fp8);

   beta = calloc(h,sizeof(double));
   freq = calloc(h,sizeof(double));
   freq_sort = calloc(h,sizeof(double));
   hap_map = calloc(h,sizeof(int));
   BETA_START = *start_beta;

   for(i=1;i<h;i++)
     beta[i] = BETA_START/sqrt(*var_trait_founder);
   beta[0] = (*mean_trait_founder_baseline - *mean_trait_founder)/sqrt(*var_trait_founder);

   fam = calloc(*num_fam,sizeof(int));
   hap_config = calloc(*num_fam,sizeof(int));
   founders = calloc(*num_fam,sizeof(int));
   non_founders = calloc(*num_fam,sizeof(int));

   fp1 = fopen("num_hap_config.txt","r");
   fp2 = fopen("num_members.txt","r");
   fp3 = fopen("founders.txt","r");
   fp4 = fopen("non-founders.txt","r");
   fp5 = fopen("hap-freq.txt","r");
   fp6 = fopen("configID.txt","r");

   // storing the haplotype frequencies

   for(i=0;i<h;i++)
     {
       fscanf(fp5,"%s %d %c",str1,&m,&c);
       for(j=0;j<num_snps;j++){
	 fscanf(fp5,"%d ",&m);
       }
       fscanf(fp5,"%lf ",&freq[i]);
     }
   
   for(i=0;i<h;i++)
     freq_sort[i] = freq[i];
   
   sort(freq_sort,h);

   // haplotype index mapping

   for(i=0;i<h;i++)
     {
       temp = freq[i];
       for(j=0;j<h;j++)
	 {
	   if(temp==freq_sort[j])
	     break;
	 }
       hap_map[i] = j + 1;
     }

   max_hap_index = max_freq_index(freq_sort,h);  

   // storing # family menbers, # haplotype config, # founders and non_founders in respective arrays 

   configID = calloc(*num_fam,sizeof(int*));
   for(i=0;i<*num_fam;i++)
     {
       for(j=0;j<9;j++)
	 fscanf(fp1,"%s ",str);
       fscanf(fp1,"%d ",&val);
       hap_config[i] = val;
       for(j=0;j<8;j++)
	 fscanf(fp2,"%s ",str);
       fscanf(fp2,"%d ",&val);
       fam[i] = val;
       for(j=0;j<8;j++)
	 fscanf(fp3,"%s ",str);
       fscanf(fp3,"%d ",&val);
       founders[i] = val;
       for(j=0;j<8;j++)
	 fscanf(fp4,"%s ",str);
       fscanf(fp4,"%d ",&val);
       non_founders[i] = val;
       configID[i] = calloc(fam[i],sizeof(int));
       fscanf(fp6,"%s",str);
       for(j=0;j<fam[i];j++)
	 {
	   fscanf(fp6,"%d",&val);
	   configID[i][j] = val;
	 }
   }

   fclose(fp1);
   fclose(fp2);
   fclose(fp3);
   fclose(fp4);
   fclose(fp5);
   fclose(fp6);

   m = 0;
   for(i=0;i<*num_fam;i++)
     {
       FAM[i].id = calloc(fam[i],sizeof(int*));
       FAM[i].fam_id = calloc(fam[i],sizeof(int));
       FAM[i].fid = calloc(fam[i],sizeof(int));
       FAM[i].mid = calloc(fam[i],sizeof(int));
       FAM[i].gender = calloc(fam[i],sizeof(int));
       FAM[i].founder = calloc(fam[i],sizeof(int));
       FAM[i].y = calloc(fam[i],sizeof(double));
       FAM[i].num_hap_config = hap_config[i];
       FAM[i].non_founder = non_founders[i];
       FAM[i].num_memb = fam[i];
       FAM[i].rows = fam[i]*hap_config[i];
       FAM[i].hap_conf = calloc(FAM[i].rows,sizeof(int *));
       FAM[i].index = calloc(non_founders[i],sizeof(int));
       FAM[i].polygenic = calloc(fam[i],sizeof(double));
       FAM[i].z_update = calloc(fam[i],sizeof(int *));
       FAM[i].tran_prob = calloc(FAM[i].num_hap_config,sizeof(double *));
       FAM[i].spouse_count = calloc(fam[i],sizeof(int));
       FAM[i].spouse = calloc(fam[i],sizeof(int *));
       FAM[i].child = calloc(fam[i],sizeof(int *));
       FAM[i].mu = calloc(fam[i],sizeof(double));
     }

   m = 0;
   for(i=0;i<*num_fam;i++)
     {
       counter = 0;
       for(j=0;j<fam[i];j++)
	 {
	   FAM[i].id[j] = calloc(2,sizeof(int));
	   FAM[i].z_update[j] = calloc(2,sizeof(int)); 
	   FAM[i].fam_id[j] = pedigree[m][0];
	   FAM[i].id[j][0] = pedigree[m][1];
	   FAM[i].fid[j] = pedigree[m][2];
	   FAM[i].mid[j] = pedigree[m][3];
	   FAM[i].gender[j] = pedigree[m][4];
	   FAM[i].y[j] = y[m];
	   FAM[i].polygenic[j] = poly[m];
	   m++;
	 }
       for(k=0;k<fam[i];k++)
	 {
	   if(FAM[i].fid[k]==0 && FAM[i].mid[k]==0)
	     {
	       FAM[i].founder[k] = 1;
	     }
	 }
       //calculating the number of children for each id and storing it in column 2 of id matrix
       for(j=0;j<fam[i];j++)
	 {
	   sum = 0;
	   for(k=0;k<fam[i];k++)
	     {
	       if(FAM[i].id[j][0]==FAM[i].fid[k] || FAM[i].id[j][0]==FAM[i].mid[k])
		 sum++;
	     }
	   FAM[i].id[j][1] = sum;
	   FAM[i].child[j] = calloc(sum,sizeof(int)); // stores array index for (ij)th person's kids
	 }
     }
   
   for(i=0;i<*num_fam;i++)
     {
       m = 0;
       for(j=0;j<fam[i];j++)
	 {
	   if(FAM[i].founder[j]==0)
	     {
	       FAM[i].index[m] = FAM[i].id[j][0];
	       m++;
	     }
	 }
     }

   // allocating memory for the haplotype matrix
   for(i=0;i<*num_fam;i++)
     {
       for(j=0;j<FAM[i].rows;j++)
	 {
	   FAM[i].hap_conf[j] = calloc(2,sizeof(int));
	 }
     }
   
   //setting up the transition probability matrix for each family
   for(i=0;i<*num_fam;i++)
     {
       for(j=0;j<FAM[i].num_hap_config;j++)
	 {
	   FAM[i].tran_prob[j] = calloc(FAM[i].non_founder,sizeof(double));
	 }
     }
   
   // extracting haplotype configurations from output file
   fp1 = fopen("extracted_fam_qbl100.txt","r");
   fp2 = fopen("all_hap_configs.txt","w");
  counter = 0;
  j = 0;
  while(counter<*num_fam)
    {
      if(j==0)
	{
	  k = 6;
	}
      else
	{
	  k = 7;
	}
      for(i=0;i<k;i++)//skip the 1st k lines
	{
	  fgets(str,SIZE,fp1);
	}
      for(i=0;i<hap_config[counter];i++)
	{
	  fgets(str,SIZE,fp1);
	  fputs(str,fp2);
	  fflush(fp2);
	}
      j = 1;
      counter++;
    }
  
  fclose(fp1);
  fclose(fp2);
  
  fp2 = fopen("all_hap_configs.txt","r");
   // creating the haplotype matrix from haplo config information file
  i = 0;
  j = 0;
  m = 0;
  while(j<*num_fam)
    {
      while(m<hap_config[j])
	{
	   fgets (str,sizeof str, fp2);
	   str[strlen(str)-1]='\0';
	   len = strlen(str);
	   k = 0; 
	   while(k<len)
	     {
	       c = str[k];
	       if(c=='(')
		 {
		   c = str[++k];
		   l = 0;
		   while(c!=')'){str1[l++] = c; c=str[++k]; }
		   str1[l] = '\0';
		   sscanf(str1,"%d %c %d",&col1,&c,&col2);
		   val = configID[j][i]; //no need of configID, need to store the haplotypes in the same order as the order of the ID's given by haplore
		   for(l=0;l<FAM[j].num_memb;l++)
		     if(val==FAM[j].id[l][0])
		       break;
		   FAM[j].hap_conf[fam[j]*m + l][0] = col1; 
		   FAM[j].hap_conf[fam[j]*m + l][1] = col2; 
		   i++;
		 }
	       k++;
	     }
	   m++;// for next configuration
	   i = 0;// for next configuration need to read the person ID from beginning of configID, i keeps track of configID sequence for each configuration
	}
      j++;// for next family, j keeps track of family
      i = 0;// new matrix for new family
      m = 0;
    }

  // naming haplotypes according to the sorted haplotypes

  for(i=0;i<*num_fam;i++)
    {
      for(j=0;j<FAM[i].rows;j++)
	{
	  val = FAM[i].hap_conf[j][0];
	  FAM[i].hap_conf[j][0] = hap_map[val-1];
	  val = FAM[i].hap_conf[j][1];
	  FAM[i].hap_conf[j][1] = hap_map[val-1];
	}
    }
  
  // function for calculating transmission probability
  for(i=0;i<*num_fam;i++)
	trans_prob_calc(FAM[i],hap_config[i],fam[i]);
  
  // assigning z_update for every family as the default 1st haplotype configuration
  for(i=0;i<*num_fam;i++){
    for(j=0;j<fam[i];j++){
      FAM[i].z_update[j][0] = FAM[i].hap_conf[j][0];
      FAM[i].z_update[j][1] = FAM[i].hap_conf[j][1];
    }
  }

  remove("num_hap_config.txt");
  remove("num_members.txt");
  remove("founders.txt");
  remove("non-founders.txt");
  //remove("hap-freq.txt");
  remove("configID.txt");
  remove("all_hap_configs.txt");
  remove("extracted_fam_qbl100.txt");

  iter = 0;
  /********************** Start MCMC Here ******************************/
  
  for(n=0;n<*num_it;n++)
  {
     for(i=0;i<*num_fam;i++){
	if(hap_config[i]>1)
	  update_Z(h,FAM[i],beta,sigma_sqE,D,freq_sort,fam[i],hap_config[i],max_hap_index);//freq replaced by freq_sort 
     }
     update_beta(sigma_sqE,FAM,beta,lambda,*num_fam,h,max_hap_index,n,*burn_in);// max_hap_index = 1
     for(i=0;i<*num_fam;i++){
       for(j=0;j<fam[i];j++){
	 k = FAM[i].z_update[j][0];
	 l = FAM[i].z_update[j][1];
	 temp = beta[0];
	 if(k==max_hap_index)
	   temp += 0.0;
	 else
	   temp += beta[k-1];
	 if(l==max_hap_index)
	   temp += 0.0;
	 else
	   temp += beta[l-1];
	 FAM[i].mu[j] = temp;
       }
     }

     lambda = update_lambda(beta,a,b,h);
     
     if(n<30000){
       sum = 0;
       for(i=0;i<*num_fam;i++){
	 sig_inv = calloc(fam[i],sizeof(double*));
	 sig_inv1 = calloc(fam[i],sizeof(double*));
	 //sig_inv = malloc(fam[i]*sizeof(float*));
	 for(j=0;j<fam[i];j++){
	   sig_inv[j] = calloc(fam[i],sizeof(double));
	   sig_inv1[j] = calloc(fam[i],sizeof(double));
	 }
	 j = sum;
	 for(l=0;l<fam[i];l++)
	   for(m=0;m<fam[i];m++)
	     sig_inv[l][m] = sigma_inv[j+l][j+m]; 
	 sum += fam[i];
	 for(j=0;j<fam[i];j++){
	   for(k=0;k<fam[i];k++){
	     if(j==k)
	       sig_inv[j][k] = 1.0/sigma_sqE + sig_inv[j][k]/sigma_sqA;
	     else
	       sig_inv[j][k] = sig_inv[j][k]/sigma_sqA;
	   }
	 }
	 mat_inv(sig_inv,sig_inv1,fam[i]);
	 update_Uj_block(FAM[i].y, FAM[i].polygenic, FAM[i].mu, sig_inv1, sigma_sqE, fam[i]);
	 dealloc2D(sig_inv,fam[i]);
	 dealloc2D(sig_inv1,fam[i]);
       }
     }
     else {
       if(n%10==0){
	 sum = 0;
	 for(i=0;i<*num_fam;i++){
	   sig_inv = calloc(fam[i],sizeof(double*));
	   sig_inv1 = calloc(fam[i],sizeof(double*));
	   for(j=0;j<fam[i];j++){
	     sig_inv[j] = calloc(fam[i],sizeof(double));
	     sig_inv1[j] = calloc(fam[i],sizeof(double));
	   }
	   j = sum;
	   for(l=0;l<fam[i];l++)
	     for(m=0;m<fam[i];m++)
	       sig_inv[l][m] = sigma_inv[j+l][j+m];
	   sum += fam[i];
	   for(j=0;j<fam[i];j++){
	     for(k=0;k<fam[i];k++){
	       if(j==k)
		 sig_inv[j][k] = 1.0/sigma_sqE + sig_inv[j][k]/sigma_sqA;
	       else
		 sig_inv[j][k] = sig_inv[j][k]/sigma_sqA;
	     }
	   }
	   mat_inv(sig_inv,sig_inv1,fam[i]);
	   update_Uj_block(FAM[i].y, FAM[i].polygenic, FAM[i].mu, sig_inv1, sigma_sqE, fam[i]);
	   dealloc2D(sig_inv,fam[i]);
	   dealloc2D(sig_inv1,fam[i]);
	 }//for i..
       }//if n
     }// else */
     
      k = 0;
      for(i=0;i<*num_fam;i++)
	for(j=0;j<fam[i];j++)
	  poly[k++] = FAM[i].polygenic[j];

      sigma_sqA = update_sigma_sqA(*N,a0,s0,poly,sigma_inv);
     
      sigma_sqE = update_sigma_sqE(FAM,*N,*num_fam,e0,t0); 
      
      update_freq(freq_sort,D,FAM,h,*num_fam,n,*burn_in);
      D = update_D(freq_sort,D,h,FAM,*num_fam,n,*burn_in); 

      iter++;
      if(n >= *burn_in)
      {
	  for(i=0;i<h;i++){
	    beta_out[it1] = beta[i];
	    freq_out[it1] = freq_sort[i];
	    it1++;
	  }
	  
	  lambda_out[it2] = lambda;
	  D_out[it2] = D;
	  ssA_out[it2] = sigma_sqA;
	  ssE_out[it2] = sigma_sqE;
	  it2++;
      }
  }
  return(1);
}


void trans_prob_calc(struct family fam,int hap_config,int fam_mem)//even if fam is array, * is important
{
  int i,j,k,ind,f,m,f_loc,m_loc,s_loc,val,flag1,flag2,v1,v2,v3,v4,s_h1,s_h2;

  i = 0;
  while(i<hap_config){
    for(j=0;j<fam.non_founder;j++){
      flag1 = 0;
      flag2 = 0;
      ind = fam.index[j]; 
      for(k=0;k<fam_mem;k++)
	if(fam.id[k][0]==ind)
	  break;
      s_loc = k; 
      f = fam.fid[k]; 
      m = fam.mid[k]; 
      val = i*fam_mem; 
      fflush(stdout);
      for(k=0;k<fam_mem;k++)
	if(fam.id[k][0]==f)
	  break;
      f_loc = k; 
      for(k=0;k<fam_mem;k++)
	if(fam.id[k][0]==m)
	  break;
      m_loc = k; 

      v1 = fam.hap_conf[val+f_loc][0]; 
      v2 = fam.hap_conf[val+f_loc][1];
      v3 = fam.hap_conf[val+m_loc][0]; 
      v4 = fam.hap_conf[val+m_loc][1]; 
      s_h1 = fam.hap_conf[val+s_loc][0]; 
      s_h2 = fam.hap_conf[val+s_loc][1]; 

      if(v1==v2)
	flag1 = 1;
      if(v3==v4)
	flag2 = 1;
      if(flag1==1 && flag2==1) 
	fam.tran_prob[i][j] = 1;
      if(flag1==1 && flag2==0) 
	fam.tran_prob[i][j] = 0.5;
      if(flag1==0 && flag2==1) 
	fam.tran_prob[i][j] = 0.5;
      if(flag1==0 && flag2==0) 
	{
	  if((v1==v3 || v1==v4) && (v2==v3 || v2==v4)) 
	    {
	      if(s_h1==s_h2) 
		fam.tran_prob[i][j] = 0.25;
	      else 
		fam.tran_prob[i][j] = 0.5;
	    }
	  else
	    fam.tran_prob[i][j] = 0.25;
	}
    }
    i++;
  }
}

double update_sigma_sqA(int N,double a0,double s0 ,double poly[],double **sigma_inv)
{
  int i,j;
  double x,sigma_sqA,alpha,beta,s,poly_new[N];
  //printf("\nN = %d, a0 = %f, s0 = %f",N,a0,s0); 
  alpha = (N + a0)/2.0 - 1.0;
  //s = 0.0;
  //for(i=0;i<100;i++)
  //Rprintf("%f ",poly[i]);

  for(i=0;i<N;i++)
    {
      s = 0.0;
      for(j=0;j<N;j++)
	s += poly[j]*sigma_inv[j][i];
      poly_new[i] = s;
    }
  //for(i=0;i<N;i++)
  //printf(" %f ",poly_new[i]);
  s = 0.0;
  for(i=0;i<N;i++)
    s += poly_new[i]*poly[i];
  //printf("\nsum = %f",s);
  //s = abs(s);
  beta = 2.0/(s+s0);
  //beta = (s+s0)/2.0; //did not work when stuck 10/20/15
  if(beta<0) 
    Rprintf("\n ssA: -ve beta:");
  GetRNGstate();
  //sigma_sqA = rinvgamma(alpha,beta);
  x = rgamma(alpha,beta); 
  PutRNGstate();
  //printf("\n x = %f ",x);
  sigma_sqA = 1.0/x;
  //printf("\n alpha = %f, beta = %f, x = %f",alpha,beta,x);
  return(sigma_sqA);
}

void update_Z(int num_hap, struct family fam, double beta[], double sigma_sqE, double D, double freq[], int num_memb, int num_hap_config, int max_hap_index)
{
  double **a,prob[num_hap_config],cum_prob[num_hap_config],sum_prob,x,mu,val,temp;
  int i,j,k,l,m,delta,index1,index2,num_founder;

  //Rprintf("\nnum_hap=%d, sigma_sqE=%f,D=%f,num_memb=%d,num_hap_config=%d",num_hap,sigma_sqE,D,num_memb,num_hap_config);
  //for(i=0;i<num_hap;i++)
  //printf("\nbeta[%d] = %f freq[%d] = %f",i+1,beta[i],i+1,freq[i]);
  
  num_founder = fam.num_memb - fam.non_founder;
  a = calloc(num_hap_config, sizeof(double *));
  for(i=0; i<num_hap_config; i++)
    a[i] = calloc(num_founder,sizeof(double));
  //fam.z_update = calloc(num_memb,sizeof(int *));

  //Rprintf("\n Before a_z values");
  //fflush(stdout);
  // calculating the a_z values 
  for(i=0; i<num_hap_config; i++)
    {
      l = 0;
      for(j=0; j<num_memb; j++)
	{
	  k = i*num_memb; // keeps track of skipping in hap_conf
	  if(fam.founder[j]==1)
	    {
	      if(fam.hap_conf[k+j][0] == fam.hap_conf[k+j][1])
		delta = 1;
	      else 
		delta = 0;
	      a[i][l] = delta*D*freq[fam.hap_conf[k+j][0]-1] + (2-delta)*(1-D)*freq[fam.hap_conf[k+j][0]-1]*freq[fam.hap_conf[k+j][1]-1]; 
	      l++;
	    }
	}
    }
  //for(i=0;i<num_hap_config;i++){
  //for(j=0;j<num_memb;j++){
  //  Rprintf("a[%d][%d] = %f ",i+1,j+1,a[i][j]);
  //}
  //Rprintf("\n");
  //}
  //Rprintf("\n Before P(Z=z|z')");
  // calculating P(Z=z|z')
  sum_prob = 0.0;
  for(k=0; k<num_hap_config; k++)
    {
      l = k*num_memb;
      val = 1.0;
      j = 0; // keeps track of tran_prob array index
      m = 0; // keeps track of aij
      for(i=0; i<num_memb; i++)
	{
	  mu = beta[0];
	  index1 = fam.hap_conf[l+i][0];
	  index2 = fam.hap_conf[l+i][1];
	  if(index1==max_hap_index)
	    mu += 0.0;
	  else
	    mu += beta[index1-1];
	  if(index2==max_hap_index)
	    mu += 0.0;
	  else
	    mu += beta[index2-1];
	  //mu = beta[fam.hap_conf[i][0]-1] + beta[fam.hap_conf[i][1]-1];
	  temp = (fam.y[i] - mu - fam.polygenic[i]);
	  //Rprintf("\nmu = %f, temp = %f",mu,temp);
	  temp = (-1)*temp*temp/(2*sigma_sqE);
	  //Rprintf("\ntemp = %f",temp);
	  temp = exp(temp);
	  //Rprintf("\nexp-temp = %f",temp);
	  if(fam.founder[i]==1)
	    {
	      temp = temp*a[k][m];
	      m++; // m keeps track of # founders
	    }
	  else
	    {
	      temp = temp*fam.tran_prob[k][j];  
	      j++; // since tran_prob has non_founder number of column, j keeps track of it
	    }
	  val *= temp; // why is val used here
	}
      prob[k] = val;
      sum_prob += val;
    }
  //printf("\nk=%d,val=%f,sum_prob=%f,temp=%f",k,val,sum_prob,temp);
  //Rprintf("\n Before Gibbs sampling");
  // Gibbs sampling
  for(i=0; i<num_hap_config; i++)
    prob[i] = prob[i]/sum_prob;
  cum_prob[0] = prob[0];
  for(i=1; i<num_hap_config; i++)
    cum_prob[i] = cum_prob[i-1] + prob[i];
  
  GetRNGstate();
  x = runif(0,1);
  PutRNGstate();
  
  if(x < cum_prob[0])
    {
      for(i=0; i<num_memb; i++)
	for(j=0; j<2; j++)
	  fam.z_update[i][j] = fam.hap_conf[i][j];
    }
  for(k=1; k<num_hap_config; k++)
    {
      if(x > cum_prob[k-1] && x < cum_prob[k])
	{
	  for(i=0; i<num_memb; i++)
	    {
	      l = k*num_memb;
	      for(j=0; j<2; j++)
		fam.z_update[i][j] = fam.hap_conf[l][j];
	    }
	}
    }
  //for(i=0;i<num_hap_config;i++)
  //free(a[i]);
  dealloc2D(a,num_hap_config);
  //free(a);
  //free(prob); free(cum_prob);
}

double update_sigma_sqE(struct family fam[],int N,int num_fam,double e0,double t0)
{
  int i,j;
  double x,alpha,beta_val,s,val,sigma_sqE;
  alpha = (N+e0)/2 - 1.0; 
  s = 0.0;
  for(i=0;i<num_fam;i++)
    {
      for(j=0;j<fam[i].num_memb;j++)
	{
	  /*mu = beta[0];
	  index1 = fam[i].z_update[j][0];
	  index2 = fam[i].z_update[j][1];
	  if(index1==max_hap_index)
	    mu += 0.0;
	  else
	    mu += beta[index1-1];
	  if(index2==max_hap_index)
	    mu += 0.0;
	  else
	  mu += beta[index2-1];*/
	  //mu = beta[fam[i].z_update[j][0]-1] + beta[fam[i].z_update[j][1]-1];
	  val = fam[i].y[j] - fam[i].mu[j] - fam[i].polygenic[j];
	  //printf("\n val %d = %f",j+1,val);
	  s += pow(val,2);
	}
    }
  //printf("\n s = %f",s);
  beta_val = 2/(s+t0);
  //beta_val = (s+t0)/2.0; //didn't work when stuck 10/20/15
  //beta_val = 1.0/s;
  GetRNGstate();
  //sigma_sqE = rinvgamma(1,alpha,beta);
  //if(beta<0)
  //Rprintf("\n in ssE: -ve beta");
  x = rgamma(alpha,beta_val);
  PutRNGstate();
  sigma_sqE = 1.0/x;
  return(sigma_sqE);
}

void update_beta(double sigma_sqE,struct family fam[],double beta[],double lambda,int num_fam,int num_hap,int max_hap_index,int it,int burn_in)
{
  int i,j,k,l,x,index1,index2;
  double beta_star,g_old,g_new,f_old,f_new,beta_new[num_hap],SD,accept_prob,sum,mu_old,mu_new,val;
  
  //printf("\n sigma_sqE = %f, num_fam = %d, num_hap = %d, max_hap_index = %d, lambda = %f",sigma_sqE,num_fam,num_hap,max_hap_index,lambda);

  for(k=0;k<num_hap;k++)
    {
      //if(k==0)
      //beta_star = gen_double_exp(beta[k],cbrt(fabs(beta[k])));
	//beta_star = gen_double_exp(beta[k],pow(beta[k],2));
	//beta_star = gen_double_exp(beta[k],fabs(log(fabs(beta[k]))));
	//beta_star = gen_double_exp(beta[k],fabs(beta[k]));
	//beta_star = gen_double_exp(beta[k],pow(fabs(beta[k]),0.9));
      //else
      //beta_star = gen_double_exp(beta[k],sqrt(fabs(beta[k])));
      //beta_star = gen_double_exp(beta[k],pow(fabs(beta[k]),.25));
      beta_star = gen_double_exp(beta[k],0.1);
	//printf("\n beta_star = %f",beta_star);
      sum = 0.0;
      for(i=0;i<num_fam;i++)
	{
	  for(j=0;j<fam[i].num_memb;j++)
	    {
	      mu_old = beta[0];
	      index1 = fam[i].z_update[j][0];
	      index2 = fam[i].z_update[j][1];
	      if(index1==max_hap_index)
		mu_old += 0.0;
	      //else if(index1<max_hap_index)
	      //mu_old += beta[index1];
	      else
		mu_old += beta[index1-1];

	      if(index2==max_hap_index)
		mu_old += 0.0;
	      //else if(index2<max_hap_index)
	      //mu_old += beta[index2];
	      else
		mu_old += beta[index2-1];

	      for(l=0;l<num_hap;l++)
		beta_new[l] = beta[l];
	      beta_new[k] = beta_star;
      
	      mu_new = beta_new[0];
	      if(index1==max_hap_index)
		mu_new += 0.0;
	      //else if(index1<max_hap_index)
	      //mu_new += beta_new[index1];
	      else
		mu_new += beta_new[index1-1];
	      if(index2==max_hap_index)
		mu_new += 0.0;
	      //else if(index2<max_hap_index)
	      //mu_new += beta_new[index2];
	      else
		mu_new += beta_new[index2-1];
	      
	      //printf("\n i=%d, j=%d, k=%d, sum = %f, mu_new = %f, mu_old = %f ",i,j,k,sum,mu_new,mu_old);
	      sum += (mu_new - mu_old)*(2*fam[i].y[j] - 2*fam[i].polygenic[j] - mu_new - mu_old);
	      //Rprintf(" sum = %f    ",(mu_new - mu_old)*(2*fam[i].y[j] - 2*fam[i].polygenic[j] - mu_new - mu_old));
	      //if(k==0 && i<5)
	      //Rprintf(" fam[%d].y[%d] = %f ", i+1,j+1,fam[i].y[j]);
	    }
	  //Rprintf("\n");
	}
      //Rprintf("\nsum after for1 = %f mu = %f",sum,mu);
      sum = sum/(2*sigma_sqE);
      //Rprintf("\nsum after for2 = %f",sum);
      sum = sum + lambda*fabs(beta[k]) - lambda*fabs(beta_star);
      //Rprintf("\nsum after for3 = %f",sum);
      //sum = (-1)*sum;
      //g_old = exp(sum);
      //g_old = (-1.0)*sum;
      
      //Rprintf("\nsum after for1 = %f, mu = %f",sum,mu);
      //sum = sum/(2*sigma_sqE);
      //Rprintf("\nsum after for2 = %f",sum);
      //sum += lambda*fabs(beta_new[k]);
      //sum += lambda*fabs(beta_star);
      //Rprintf("\nsum after for3 = %f",sum);
      //sum = (-1)*sum;
      //g_new = exp(sum);
      //g_new = (-1)*sum;

      //SD = sqrt(fabs(beta_star));
      //SD = cbrt(fabs(beta_star));
      //SD = pow(fabs(beta_star),.25);
      //SD = fabs(log(fabs(beta_star)));
      SD = 0.1;
      //SD = pow(beta_star,2);
      f_old = exp(-sqrt(2)*fabs(beta[k]-beta_star)/SD)/(sqrt(2)*SD);
      //SD = sqrt(fabs(beta[k]));
      //SD = cbrt(fabs(beta[k]));
      //SD = pow(fabs(beta[k]),.25);
      //SD=fabs(log(fabs(beta[k])))
      SD = 0.1;
      //SD = pow(beta[k],2);
      f_new = exp(-sqrt(2)*fabs(beta[k]-beta_star)/SD)/(sqrt(2)*SD);
      //Rprintf("\n f_old = %f, f_new = %f ",f_old,f_new);
      
      //accept_prob = (g_new*f_old)/(g_old*f_new);
      //if(fabs(g_new-g_old)>12.0)
      //accept_prob = f_old/f_new;
	//else
      //accept_prob = (exp(g_new-g_old))*(f_old/f_new);
      //Rprintf("\n g-old - g_new = %f",sum);
      accept_prob = exp(sum)*(f_old/f_new);
      //Rprintf(" acceptance prob: %f ",accept_prob);
	
      //if(f_new==0)
	//Rprintf("\n in Beta: zero f_new");
      //Rprintf("\nf_new=%f f_old=%f",f_new,f_old);
      //Rprintf("\naccept_prob=%f",accept_prob);
      if (accept_prob > 1)
	beta[k] = beta_star;
      else
	{
	  GetRNGstate();
	  x = rbinom(1,accept_prob);
	  PutRNGstate();
	  //Rprintf("\n x = %d", x);
	  if (x == 1) beta[k] = beta_star; 
	}
      if(it>=burn_in)
	{
	  if(accept_prob>1 || x==1)
	    {
	      be[k] += 1.0;
	    }
	}
    }
  //free(beta_new);
}

double update_lambda(double beta[], double a, double b, int num_hap)
{
  double lambda, beta_abs[num_hap];
  int i;
  //Rprintf("\n a=%f, b=%f, num_hap=%d",a,b,num_hap);
  for (i=0; i<num_hap; i++)
    beta_abs[i] = fabs(beta[i]);
  //Rprintf("\n a+num_hap=%f, b+sum=%f",a+num_hap,sum(beta_abs,num_hap)+b);
  GetRNGstate();
  lambda=rgamma((double) a+num_hap, 1/(sum(beta_abs, num_hap)+b));
  PutRNGstate();
  //free(beta_abs);
  return lambda;
}


void update_Uij(double sigma_sqE,double sigma_sqA,struct family fam[],double beta[],int num_fam,int max_hap_index)
{
  int i,j,k,l,f,m,fid,mid,index1,index2,count_kid,count_spouse;
  double sigma_sq,eta,mu,poly_child=0.0,poly_spouse=0.0,indicator=0.0,sd,x;
 
  //printf("\n");
  //for(i=0;i<6;i++)
  //printf(" beta[%d] = %f ",i,beta[i]);
  /*for(i=0;i<num_fam;i++)
    {
      for(j=0;j<fam[i].num_memb;j++)
	{
	  printf("\n founder = %d, fam[%d].id[%d][0] = %d, fam[%d].fid[%d] = %d, mid[%d] = %d",fam[i].founder[j],i,j,fam[i].id[j][0],i,j,fam[i].fid[j],j,fam[i].mid[j]);
	}
    }*/
  for(i=0;i<num_fam;i++)
    {
      for(j=0;j<fam[i].num_memb;j++)
	{
	  poly_child = 0.0;
	  poly_spouse = 0.0;
	  if(fam[i].founder[j]==0) 
	    indicator = 1.0;
	  else
	    indicator = 0.0;
	  sigma_sq = 1/sigma_sqE + (1+indicator)/sigma_sqA + fam[i].id[j][1]/(2*sigma_sqA);
	  sigma_sq = 1/sigma_sq;
     
	  mu = beta[0];
	  index1 = fam[i].z_update[j][0];
	  index2 = fam[i].z_update[j][1];
	  //Rprintf("\n index1 = %d, index2 = %d",index1,index2);
	  if(index1==max_hap_index)
	    mu += 0.0;
	  //else if(index1<max_hap_index)
	  //mu += beta[index1];
	  else
	    mu += beta[index1-1];
	  if(index2==max_hap_index)
	    mu += 0.0;
	  //else if(index2<max_hap_index)
	  //mu += beta[index2];
	  else 
	    mu += beta[index2-1];
	  //mu = beta[fam[i].z_update[j][0]-1] + beta[fam[i].z_update[j][1]-1];
	  //Rprintf("\n mu = %f", mu);
	  fid = fam[i].fid[j]; //fid of the current person
	  mid = fam[i].mid[j]; //mid of the current person
	  f = 0;
	  m = 0;
	  if(fam[i].founder[j]==0) // do the loop if the person is non-founder
	    {
	      for(l=0;l<fam[i].num_memb;l++)
		{
		  if(fam[i].id[l][0] == fid)
		    break;
		} 
	      f = l;//storing index of present person's father
	    
	      for(l=0;l<fam[i].num_memb;l++)
		{
		  if(fam[i].id[l][0] == mid)
		    break;
		}
	      m = l;// storing index of present person's mother
	    }
	  count_kid = fam[i].id[j][1];
	  if(count_kid>0)// if the person has kids
	    {
	      poly_child = 0.0;
	      for(k=0;k<count_kid;k++)
		{
		  poly_child += fam[i].polygenic[fam[i].child[j][k]];// sum of polygenic values of the kids of the present parent
		  //Rprintf("\nper_id = %d, count_kid = %d, child[%d]= %d",fam[i].id[j][0],count_kid,k,fam[i].child[j][k]);
		}
	      poly_child = 2*poly_child;
	    }
	  //poly_spouse = 0.0; // commented after debug 11/02/2015
	  count_spouse = fam[i].spouse_count[j];
	  if(count_spouse > 0)
	    {
	      poly_spouse = 0.0;
	      for(k=0;k<count_spouse;k++)
		{
		  poly_spouse += fam[i].polygenic[fam[i].spouse[j][k]];//summing up polygenic effects of all spouses of father
		  //Rprintf("\nper_id = %d, count_spouse = %d, spouse[%d]= %d",fam[i].id[j][0],count_spouse,k+1,fam[i].spouse[j][k]);
		}
	    }
	  //Rprintf("\n part1 = %f, part2 = %f, part3 = %f ",(fam[i].y[j]-mu)/sigma_sqE,indicator*(fam[i].polygenic[f]+fam[i].polygenic[m])/sigma_sqA,(poly_child - poly_spouse)/(2*sigma_sqA));
	  //Rprintf("\n poly_child = %f, poly_spouse = %f",poly_child,poly_spouse);
	  eta = sigma_sq*((fam[i].y[j]-mu)/sigma_sqE + indicator*(fam[i].polygenic[f]+fam[i].polygenic[m])/sigma_sqA + (poly_child - poly_spouse)/(2*sigma_sqA));
	  
	  sd = sqrt(sigma_sq);
	  //Rprintf("\n eta = %f, sigma_sq = %f", eta,sigma_sq);
	  GetRNGstate();
	  x = rnorm(eta,sd);
	  PutRNGstate();
	  fam[i].polygenic[j] = x;
	}
    }
}

// function performing block update of Uj's

//void update_Uj_block(double y[], double Uj[], double MUj[], double **sigmaJ_inv, double sigma_sqA, double sigma_sqE, int nj, int max_hap_index)
void update_Uj_block(double y[], double Uj[], double MUj[], double **sigma_inv, double sigma_sqE, int nj)
{
  //double **sigma,**sigma_inv,*yj_muj,*mu;
  float *covm,*mu_float,*parm,*uj;
  double *yj_muj,*mu;
  int i,j,k;
  
  //sigma = calloc(nj,sizeof(double *));
  //sigma_inv = calloc(nj,sizeof(double *));
  yj_muj = calloc(nj,sizeof(double));
  mu = calloc(nj,sizeof(double));
  covm = calloc((nj*nj),sizeof(float));
  mu_float = calloc(nj,sizeof(float));
  parm = calloc((nj*(nj+3)/2+1),sizeof(float));
  uj = calloc(nj,sizeof(float));
  
  //printf("\n");
  /*for(i=0;i<nj;i++){
    printf(" y[%d] = %f Uj[%d] = %f MUj[%d] = %f sigma_sqE = %f nj = %d ",i+1,y[i],i+1,Uj[i],i+1,MUj[i],sigma_sqE,nj);
    printf("\n");
  }
  printf("\n\n");*/
    
  /*for(i=0;i<nj;i++){
    sigma[i] = calloc(nj,sizeof(double));
    sigma_inv[i] = calloc(nj,sizeof(double));
    }*/

  // creating the sigma matrix for MVN
  for(i=0;i<nj;i++){
    yj_muj[i] = (y[i] - MUj[i])/sigma_sqE;
    /*for(j=0;j<nj;j++){
      if(i==j)
	sigma[i][j] = 1.0/sigma_sqE + sigmaJ_inv[i][j]/sigma_sqA;
      else
	sigma[i][j] = sigmaJ_inv[i][j]/sigma_sqA;
	}*/
    }
 
  //mat_inv(sigma,sigma_inv,nj);
  /*for(i=0;i<nj;i++){
    for(j=0;j<nj;j++)
      printf(" %f ",sigma_inv[i][j]);
    printf("\n");
    }*/
  mat_vec_mult(sigma_inv,yj_muj,mu,nj);
  //printf("\n Printing means: \n");
  //for(i=0;i<nj;i++)
  //printf(" %f ",mu[i]);
  
  k = 0;
  for(i=0;i<nj;i++){
    mu_float[i] = (float) mu[i];
    for(j=0;j<nj;j++){
      covm[k] = (float) sigma_inv[i][j];
      k++;
    }
  }

  setgmn(mu_float,covm,nj,parm);
  uj = genmn(parm);

  for(i=0;i<nj;i++)
    Uj[i] = (double) uj[i];
  
  //printf("\n Printing Uj's \n");
  //for(i=0;i<nj;i++)
  //printf(" %f ",Uj[i]);

  //dealloc2D(sigma,nj); dealloc2D(sigma_inv,nj);
  free(yj_muj); free(mu);
  free(mu_float); free(covm); free(parm); free(uj);
  return;
}


void update_freq(double freq[], double D, struct family fam[], int h, int num_family,int it,int burn_in)
{
  int i,j,C=10000,update=0,delta,total_freq_update=0;
  double prop_freq[h],b_old[h],b_new[h],min_f_old,min_f_new,g_old,g_new,f_new,f_old,accept_prob=0.0,aij_old=1.0,aij_new=1.0,max;
  
  GetRNGstate();
  for(i=0; i<h; i++)
    b_old[i] = freq[i]*C;
  dirichlet(b_old, h, prop_freq);
  min_f_old = find_min(freq, h);
  
  //check if the constraint -min fk/(i-min fk) < d is satisfied 
  min_f_new = find_min(prop_freq, h);
  if(-min_f_new/(1-min_f_new) < D)
    {
      // needed in acceptance prob. computation
      for(i=0; i<h; i++)
	{
	  b_new[i] = prop_freq[i]*C;
	  if(b_new[i]<=0)
	    {
	      printf("Warning: prop_freq=%e, b_new=%lf\n", prop_freq[i], b_new[i]);
	      for(j=0; j<h; j++)
		printf("%e ",prop_freq[j]);
	    }
	}
      g_old = log(1 - min_f_old);
      g_new = log(1 - min_f_new);
  // to do: the two if's might be merged, check!!

      for(i=0; i<num_family; i++)
	{
	  for(j=0; j<fam[i].num_memb; j++)
	    {
	      if(fam[i].founder[j] == 1) // aij_new and aij_old only calculated for founders
		{
		  if(fam[i].z_update[j][0] == fam[i].z_update[j][1])
		    delta = 1;
		  else 
		    delta = 0;
		  aij_old = delta*D*freq[fam[i].z_update[j][0]-1] + (2-delta)*(1-D)*freq[fam[i].z_update[j][0]-1]*freq[fam[i].z_update[j][1]-1];
		  g_old += log(aij_old);
		  aij_new = delta*D*prop_freq[fam[i].z_update[j][0]-1] + (2-delta)*(1-D)*prop_freq[fam[i].z_update[j][0]-1]*prop_freq[fam[i].z_update[j][1]-1];
		  g_new += log(aij_new); 
		}
	    }
	}
  
  /* calculate f(f*|f^(t)) = f_new and f(f^(t)|f*) = f_old */
      
      f_old = lgammafn(C);
      f_new = f_old;
      
      for (i=0; i<h; i++)
	{
	  f_old += (b_new[i]-1)*log(freq[i]) - lgammafn(b_new[i]);
	  f_new += (b_old[i]-1)*log(prop_freq[i]) - lgammafn(b_old[i]);
	}
            
  accept_prob = exp(g_new-g_old+f_old-f_new);
  //accept_prob = (g_new/g_old)*exp(f_old-f_new);
  //printf("\ng_new=%f, g_old=%f, f_new=%f, f_old=%f",g_new,g_old,f_new,f_old); 
  //printf("\n accept_prob = %f",accept_prob);

  if (-min_f_new/(1-min_f_new)  > D) 
    accept_prob = 0;
      
  if (accept_prob > 1) 
    update = 1;
  else 
    update = rbinom(1, accept_prob);
  if (update ==1) 
    {
      for (i=0; i<h; i++)
	    freq[i] = prop_freq[i];
	  ++total_freq_update;
    }

  if(it>=burn_in)
	{
	  if(update==1)
	    {
	      fr += 1.0;
	    }
	}
    }//if(-min_f_new/()<D)

  if (-min_f_old/(1-min_f_old)  > D) 
    {
      printf("error in updating f: Min f_old and D constraint violated min_f_old=%f\n", min_f_old);
      for (i=0; i<h; i++)
	printf("%f\n", freq[i]);
      printf("%f\n", D);
      exit(1);
    }

  if ((-min_f_new/(1-min_f_new))  > D && accept_prob>0) 
    {
      printf("error in updating f: Min f_new and D constraint violated ");
      exit(1);
    }

  PutRNGstate();
  //free(prop_freq); free(b_old); free(b_new);
}

double update_D(double freq[], double D, int h, struct family fam[],int num_family,int it,int burn_in)
{
  int i,j,update = 0;
  double prop_D, accept_prob, g_old=0.0, g_new=0.0, min_f, delta=0.05, lower, upper, f_old, f_new, aij_old=1.0, aij_new=1.0, del, max;

  GetRNGstate();

  min_f = find_min(freq, h);
  lower = D-delta;
  upper = D+delta;

  if (lower < -min_f/(1-min_f)) 
    lower = -min_f/(1-min_f);
  if (upper > 1) 
    upper = 1;

  prop_D = runif(lower, upper);
  
  for(i=0; i<num_family; i++)
    {
      for(j=0; j<fam[i].num_memb; j++)
	{
	  if(fam[i].founder[j]==1) // aij_new and aij_old only calculated for founders
	    {
	      if(fam[i].z_update[j][0] == fam[i].z_update[j][1])
		del = 1;
	      else 
		del = 0;
	      aij_old = del*D*freq[fam[i].z_update[j][0]-1] + (2-del)*(1-D)*freq[fam[i].z_update[j][0]-1]*freq[fam[i].z_update[j][1]-1];
	      g_old += aij_old;
	      aij_new = del*prop_D*freq[fam[i].z_update[j][0]-1] + (2-del)*(1-prop_D)*freq[fam[i].z_update[j][0]-1]*freq[fam[i].z_update[j][1]-1];
	      g_new += aij_new;
	    }
	}
    }
  
  // max = find_max_ratio(freq, h);
  //g_old = aij_old/(1-max);
  //g_new = aij_new/(1-max);

  f_new = 1/(upper-lower);

  lower = prop_D-delta;
  upper = prop_D+delta;
  if (lower < -min_f/(1-min_f)) 
    lower = -min_f/(1-min_f);
  if (upper > 1) 
    upper = 1;

  f_old = 1/(upper-lower);
 
  //accept_prob = (g_new/g_old)*(f_old/f_new);
  accept_prob = exp(g_new-g_old)*f_old/f_new;

  if (-min_f/(1-min_f) > D || -min_f/(1-min_f) > prop_D)
    {
      printf("error in updating D:  Min f and D constraint violated ");
      exit(1);
    }
  
  if (accept_prob > 1) 
    update = 1;
  else 
    update = rbinom(1, accept_prob);

  if(it>=burn_in)
	{
	  if(update==1)
	    {
	      d_val += 1.0;
	    }
	}

    if (update == 1) 
      return prop_D;

  else
    return D;
      
  PutRNGstate();
}

// function to generate from double exponential distribution

double gen_double_exp(double mean, double SD)
{
  double x, gen_exp;

  GetRNGstate();
  x = runif(0,1);
  gen_exp = rexp(SD/sqrt(2));
  PutRNGstate();

  if(x > 0.5)
    return gen_exp+mean;
  else
    return -gen_exp+mean;
}

// function to generate from Dirichlet distribution

void dirichlet(double *param, int dim, double *gen_sample)
{
  int i;
  double gen_gamma[dim], sum_gamma=0.0;
  
  GetRNGstate();
  for(i=0; i<dim; i++)
    {
      if(param[i]<=0)
	printf("Warning: param=%lf\n",param[i]);
      gen_gamma[i] = rgamma(param[i], 1);
      if(gen_gamma[i]<0.000001) gen_gamma[i] = 0.000001;
      if(gen_gamma[i]<=0)
	printf("Warning: gen_gamma=%lf, param=%lf\n", gen_gamma[i], param[i]);
      // sum_gamma += gen_gamma[i];
    }
  sum_gamma = sum(gen_gamma, dim);
  for(i=0; i<dim; i++)
    gen_sample[i] = gen_gamma[i]/sum_gamma;
  PutRNGstate();
  //free(gen_gamma);
}

// function for matrix inverse

void mat_inv(double **mat,double **mat_inv,int dimension)
{
  double **augmentedmatrix; // 2D array declared to store augmented matrix 
  double temporary, r, det;
  int i, j, k, temp; 
  
  /*det = determinant(mat,dimension);
  if(det<0.0000001){
    printf("\n matrix is singular..aborting!!\n");
    fflush(stdout);
    exit(0);
    }*/
  augmentedmatrix = calloc(dimension,sizeof(double*));
  for(i=0;i<dimension;i++)
    augmentedmatrix[i] = calloc(2*dimension,sizeof(double));

  for(i=0; i<dimension; i++)
    for(j=0; j<dimension; j++)
      augmentedmatrix[i][j] = mat[i][j];


  /* augmenting with identity matrix of similar dimensions */

 for(i=0;i<dimension; i++)
  for(j=dimension; j<2*dimension; j++)
      if(i==j%dimension)
         augmentedmatrix[i][j]=1;
      else
         augmentedmatrix[i][j]=0;

 /*for(i=0;i<dimension;i++){
    for(j=0;j<2*dimension;j++)
      printf(" %f ",augmentedmatrix[i][j]);
    printf("\n");
    }*/
 /* using gauss-jordan elimination */

 for(j=0; j<dimension; j++)
 {
  temp=j;
  //printf(" \n temp=%d, j = %d",temp,j);
 /* finding maximum jth column element in last (n-j) rows */

  for(i=j+1; i<dimension; i++)
    if(augmentedmatrix[i][j]>augmentedmatrix[temp][j])
      temp=i;

  if(fabs(augmentedmatrix[temp][j])<0.0001)
    {
      printf("\n Elements are too small to deal with !!!");
      fflush(stdout);
      //goto end;
    }

 /* swapping row which has maximum jth column element */

  if(temp!=j)
    for(k=0; k<2*dimension; k++)
      {
	temporary=augmentedmatrix[j][k] ;
	augmentedmatrix[j][k]=augmentedmatrix[temp][k] ;
	augmentedmatrix[temp][k]=temporary ;
      }

/* performing row operations to form required identity matrix out of the input matrix */

  for(i=0; i<dimension; i++)
    if(i!=j)
      {
	r=augmentedmatrix[i][j];
	for(k=0; k<2*dimension; k++)
	  augmentedmatrix[i][k]-=(augmentedmatrix[j][k]/augmentedmatrix[j][j])*r ;
      }
    else
      {
	r=augmentedmatrix[i][j];
	for(k=0; k<2*dimension; k++)
	  augmentedmatrix[i][k]/=r ;
      }

 }// for j=0

 /* Display augmented matrix */

 /*printf("\n After Gauss-Jordan elimination, augmented matrix is : \n\n") ;

 for(i=0; i<dimension; i++)
 {
  for(j=0; j<2*dimension; j++)
            printf("  %4.2f",augmentedmatrix[i][j]) ;
  printf("\n");
  }*/

 /* displaying inverse of the non-singular matrix */

 //printf("\n\n\n The inverse of the entered non-singular matrix is : \n\n");

 for(i=0; i<dimension; i++)
 {
   for(j=dimension,k=0; j<2*dimension; j++,k++)
     //printf("  %.5f",augmentedmatrix[i][j]);
     mat_inv[i][k] = augmentedmatrix[i][j];
   //printf("\n");
 }
 //end: printf("\n Matrix inverse could not be found:"); 
 dealloc2D(augmentedmatrix,dimension);
 //free(augmentedmatrix);
}

// multiplication of Matrix with Vector

void mat_vec_mult(double **mat, double vec[], double out[], int n)
{
  int i,j;
  double sum = 0.0;
  for(i=0;i<n;i++){
    sum = 0.0;
    for(j=0;j<n;j++)
      sum += mat[i][j]*vec[j];
    out[i] = sum;
  }
}

// For deallocating 2D array

void dealloc2D(double **mat,int n)
{
  int i;
  for(i=0;i<n;i++)
    free(mat[i]);
  free(mat);
}

/*For calculating Determinant of the Matrix */

double determinant(double **a,int k)
{
  double s=1.0,det=0.0,**b;
  int i,j,m,n,c;
  b = calloc(k,sizeof(double *));
  for(i=0;i<k;i++)
    b[i] = calloc(k,sizeof(double));
  if (k==1)
    {
     return (a[0][0]);
    }
  else
    {
     det=0.0;
     for (c=0;c<k;c++)
       {
        m=0;
        n=0;
        for (i=0;i<k;i++)
          {
            for (j=0;j<k;j++)
              {
                b[i][j]=0.0;
                if (i != 0 && j != c)
                 {
                   b[m][n]=a[i][j];
                   if (n<(k-2))
                    n++;
                   else
                    {
                     n=0;
                     m++;
                     }
                   }
               }
             }
          det=det + s * (a[0][c] * determinant(b,k-1));
          s=-1 * s;
          }
    }

    return (det);
}

// function to find miximum from an array

int max_freq_index(double freq[], int len)
{
  double max;
  int i, index=0;
  max = 0.0;
  for(i=0; i<len; i++)
    {
      if(max<=freq[i]){
	max = freq[i];
	index = i+1;
      }
    }
  return index;
}

// function to find the maximum ratio from an array

double find_max_ratio(double *arr, int n)
{
  int i;
  double max, ratio[n];
  
  for(i=0; i<n; i++)
    ratio[i] = -arr[i]/(1-arr[i]);
  max = ratio[0];
  for(i=1; i<n; i++)
    {
      if(max < ratio[i])
	max = ratio[i];
    }
  return max;
}

// function to find the minimum from an array

double find_min(double *arr, int n)
{
  int i;
  double min = arr[0];
  
  for(i=1; i<n; i++)
    {
      if(min > arr[i])
	min = arr[i];
    }
  return min;
}

/* function to find sum of real numbers */

double sum(double x[], int n)
{
  double sum=0.0;
  int i;

  for (i=0; i<n ; i++)
    sum = sum + x[i];
  
  return sum;

}

//function to sort a given array in descending order

void sort(double freq_sort[], int h)
{
  int i,j;
  double temp;
  for(i=0;i<h-1;i++)
    {
      for(j=i+1;j<h;j++)
	{
	  if(freq_sort[i]<freq_sort[j])
	    {
	      temp = freq_sort[i];
	      freq_sort[i] = freq_sort[j];
	      freq_sort[j] = temp;
	    }
	}
    }
}

//function to match part of two strings

int match(char text[], char pattern[]) {
  int c, d, e, text_length, pattern_length, position = -1;
 
  text_length    = strlen(text);
  pattern_length = strlen(pattern);
 
  if (pattern_length > text_length) {
    return -1;
  }
 
  for (c = 0; c <= text_length - pattern_length; c++) {
    position = e = c;
 
    for (d = 0; d < pattern_length; d++) {
      if (pattern[d] == text[e]) {
        e++;
      }
      else {
        break;
      }
    }
    if (d == pattern_length) {
      return position;
    }
  }
  return -1;
}


void setgmn ( float meanv[], float covm[], int p, float parm[] )
/*
  Purpose:
    SETGMN sets data for the generation of multivariate normal deviates.
  Discussion:
    This procedure places P, MEANV, and the Cholesky factorization of
    COVM in GENMN.
  Parameters:
    Input, float MEANV[P], the means of the multivariate 
    normal distribution.
    Input/output, float COVM[P*P].  On input, the covariance
    matrix of the multivariate distribution.  On output, the information 
    in COVM has been overwritten.
    Input, int P, the number of dimensions.
    Output, float PARM[P*(P+3)/2+1], parameters needed to generate
    multivariate normal deviates.
*/
{
  int i;
  int icount;
  int info;
  int j;
  if ( p <= 0 )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "SETGMN - Fatal error!\n" );
    fprintf ( stderr, "  P was not positive.\n" );
    exit ( 1 );
  }
//    Store P.
  parm[0] = p;
//   Store MEANV.
  for ( i = 0; i < p; i++ )
  {
    parm[1+i] = meanv[i];
  }
/*   Compute the Cholesky decomposition. */
  info = spofa ( covm, p, p );
  if ( info != 0 )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "SETGMN - Fatal error!\n" );
    fprintf ( stderr, "  SPOFA finds COVM not positive definite.\n" );
    exit ( 1 );
  }
/*   Store the upper half of the Cholesky factor. */
  icount = p + 1;
  for ( i = 0; i < p; i++ )
  {
    for ( j = i; j < p; j++ )
    {
      parm[icount] = covm[i+j*p];
      icount = icount + 1;
    }
  }
  return;
}
/******************************************************************************/


float *genmn ( float parm[] )
/*
  Purpose:
    GENMN generates a multivariate normal deviate.
  Discussion:
    The method is:
    1) Generate P independent standard normal deviates - Ei ~ N(0,1)
    2) Using Cholesky decomposition find A so that A'*A = COVM
    3) A' * E + MEANV ~ N(MEANV,COVM)
    Note that PARM contains information needed to generate the
    deviates, and is set up by SETGMN.
    PARM(1) contains the size of the deviates, P
    PARM(2:P+1) contains the mean vector.
    PARM(P+2:P*(P+3)/2+1) contains the upper half of the Cholesky
    decomposition of the covariance matrix.
  Parameters:
    Input, float PARM[P*(P+3)/2+1], parameters set by SETGMN.!
    Output, float GENMN[P], a random deviate from the distribution.
*/
{
  float ae;
  int i;
  int icount;
  int j;
  int p;
  float *work;
  float *x;
  p = ( int ) ( parm[0] );
/*   Generate P independent normal deviates. */
  work = ( float * ) malloc ( p * sizeof ( float ) );
  for ( i = 0; i < p; i++ )
  {
    work[i] = snorm ( );
  }
/*   Compute X = MEANV + A' * WORK */
  x = ( float * ) malloc ( p * sizeof ( float ) );
  for ( i = 0; i < p; i++ )
  {
    icount = 0;
    ae = 0.0;
    for ( j = 0; j <= i; j++ )
    {
      icount = icount + j;
      ae = ae + parm[i+j*p-icount+p+1] * work[j];
    }
    x[i] = ae + parm[i+1];
  }
  free ( work );
  return x;
}
/******************************************************************************/


int spofa ( float a[], int lda, int n )
/*
  Purpose:
    SPOFA factors a real symmetric positive definite matrix.
  Discussion:
    SPOFA is usually called by SPOCO, but it can be called
    directly with a saving in time if RCOND is not needed.
    Parameters:
    Input/output, float A[LDA*N].  On input, the symmetric matrix
    to be  factored.  Only the diagonal and upper triangle are used.
    On output, an upper triangular matrix R so that A = R'*R
    where R' is the transpose.  The strict lower triangle is unaltered.
    If INFO /= 0, the factorization is not complete.
    Input, int LDA, the leading dimension of the array A.
    Input, int N, the order of the matrix.
    Output, int SPOFA, error flag.
    0, for normal return.
    K, signals an error condition.  The leading minor of order K is not
    positive definite.
*/
{
  int info;
  int j;
  int k;
  float s;
  float t;
  for ( j = 1; j <= n; j++ )
  {
    s = 0.0;
    for ( k = 1; k <= j-1; k++ )
    {
      t = a[k-1+(j-1)*lda] - sdot ( k-1, a+0+(k-1)*lda, 1, a+0+(j-1)*lda, 1 );
      t = t / a[k-1+(k-1)*lda];
      a[k-1+(j-1)*lda] = t;
      s = s + t * t;
    }
    s = a[j-1+(j-1)*lda] - s;
    if ( s <= 0.0 )
    {
      info = j;
      return info;
    }
    a[j-1+(j-1)*lda] = sqrt ( s );
  }
  info = 0;
  return info;
}
/******************************************************************************/


float sdot ( int n, float dx[], int incx, float dy[], int incy )
/*
  Purpose:

    SDOT forms the dot product of two vectors.

  Parameters:

    Input, int N, the number of entries in the vectors.

    Input, float DX[*], the first vector.

    Input, int INCX, the increment between successive entries in DX.

    Input, float DY[*], the second vector.

    Input, int INCY, the increment between successive entries in DY.

    Output, float SDOT, the sum of the product of the corresponding
    entries of DX and DY.
*/
{
  float dtemp;
  int i;
  int ix;
  int iy;
  int m;

  dtemp = 0.0;

  if ( n <= 0 )
  {
    return dtemp;
  }
/*
  Code for unequal increments or equal increments
  not equal to 1.
*/
  if ( incx != 1 || incy != 1 )
  {
    if ( 0 <= incx )
    {
      ix = 0;
    }
    else
    {
      ix = ( - n + 1 ) * incx;
    }

    if ( 0 <= incy )
    {
      iy = 0;
    }
    else
    {
      iy = ( - n + 1 ) * incy;
    }

    for ( i = 0; i < n; i++ )
    {
      dtemp = dtemp + dx[ix] * dy[iy];
      ix = ix + incx;
      iy = iy + incy;
    }
  }
/*
  Code for both increments equal to 1.
*/
  else
  {
    m = n % 5;

    for ( i = 0; i < m; i++ )
    {
      dtemp = dtemp + dx[i] * dy[i];
    }

    for ( i = m; i < n; i = i + 5 )
    {
      dtemp = dtemp + dx[i  ] * dy[i  ] 
                    + dx[i+1] * dy[i+1] 
                    + dx[i+2] * dy[i+2] 
                    + dx[i+3] * dy[i+3] 
                    + dx[i+4] * dy[i+4];
    }

  }

  return dtemp;
}
/******************************************************************************/


float snorm ( )
{
  const float a[32] = {
        0.0000000, 0.3917609E-01, 0.7841241E-01, 0.1177699, 
        0.1573107, 0.1970991,     0.2372021,     0.2776904, 
        0.3186394, 0.3601299,     0.4022501,     0.4450965, 
        0.4887764, 0.5334097,     0.5791322,     0.6260990, 
        0.6744898, 0.7245144,     0.7764218,     0.8305109, 
        0.8871466, 0.9467818,     1.009990,      1.077516, 
        1.150349,  1.229859,      1.318011,      1.417797, 
        1.534121,  1.675940,      1.862732,      2.153875 };
  float aa;
  const float d[31] = {
        0.0000000, 0.0000000, 0.0000000, 0.0000000, 
        0.0000000, 0.2636843, 0.2425085, 0.2255674, 
        0.2116342, 0.1999243, 0.1899108, 0.1812252, 
        0.1736014, 0.1668419, 0.1607967, 0.1553497, 
        0.1504094, 0.1459026, 0.1417700, 0.1379632, 
        0.1344418, 0.1311722, 0.1281260, 0.1252791, 
        0.1226109, 0.1201036, 0.1177417, 0.1155119, 
        0.1134023, 0.1114027, 0.1095039 };
  const float h[31] = {
        0.3920617E-01, 0.3932705E-01, 0.3950999E-01, 0.3975703E-01, 
        0.4007093E-01, 0.4045533E-01, 0.4091481E-01, 0.4145507E-01, 
        0.4208311E-01, 0.4280748E-01, 0.4363863E-01, 0.4458932E-01, 
        0.4567523E-01, 0.4691571E-01, 0.4833487E-01, 0.4996298E-01, 
        0.5183859E-01, 0.5401138E-01, 0.5654656E-01, 0.5953130E-01, 
        0.6308489E-01, 0.6737503E-01, 0.7264544E-01, 0.7926471E-01, 
        0.8781922E-01, 0.9930398E-01, 0.1155599,     0.1404344, 
        0.1836142,     0.2790016,     0.7010474 };
  int i;
  float s;
  const float t[31] = {
        0.7673828E-03, 0.2306870E-02, 0.3860618E-02, 0.5438454E-02, 
        0.7050699E-02, 0.8708396E-02, 0.1042357E-01, 0.1220953E-01, 
        0.1408125E-01, 0.1605579E-01, 0.1815290E-01, 0.2039573E-01, 
        0.2281177E-01, 0.2543407E-01, 0.2830296E-01, 0.3146822E-01, 
        0.3499233E-01, 0.3895483E-01, 0.4345878E-01, 0.4864035E-01, 
        0.5468334E-01, 0.6184222E-01, 0.7047983E-01, 0.8113195E-01, 
        0.9462444E-01, 0.1123001,     0.1364980,     0.1716886, 
        0.2276241,     0.3304980,     0.5847031 };
  float tt;
  float u;
  float ustar;
  float value;
  float w;
  float y;

  u = r4_uni_01 ( );
  if ( u <= 0.5 )
  {
    s = 0.0;
  }
  else
  {
    s = 1.0;
  }
  u = 2.0 * u - s;
  u = 32.0 * u;
  i = ( int ) ( u );
  if ( i == 32 )
  {
    i = 31;
  }
/*
  Center
*/
  if ( i != 0 )
  {
    ustar = u - ( float ) ( i );
    aa = a[i-1];

    for ( ; ; )
    {
      if ( t[i-1] < ustar )
      {
        w = ( ustar - t[i-1] ) * h[i-1];

        y = aa + w;

        if ( s != 1.0 )
        {
          value = y;
        }
        else
        {
          value = -y;
        }
        return value;
      }
      u = r4_uni_01 ( );
      w = u * ( a[i] - aa );
      tt = ( 0.5 * w + aa ) * w;

      for ( ; ; )
      {
        if ( tt < ustar )
        {
          y = aa + w;
          if ( s != 1.0 )
          {
            value = y;
          }
          else
          {
            value = -y;
          }
          return value;
        }

        u = r4_uni_01 ( );

        if ( ustar < u )
        {
          break;
        }
        tt = u;
        ustar = r4_uni_01 ( );
      }
      ustar = r4_uni_01 ( );
    }
  }
/*
  Tail
*/
  else
  {
    i = 6;
    aa = a[31];

    for ( ; ; )
    {
      u = u + u;

      if ( 1.0 <= u )
      {
        break;
      }
      aa = aa + d[i-1];
      i = i + 1;
    }

    u = u - 1.0;
    w = u * d[i-1];
    tt = ( 0.5 * w + aa ) * w;

    for ( ; ; )
    {
      ustar = r4_uni_01 ( );

      if ( tt < ustar )
      {
        y = aa + w;
        if ( s != 1.0 )
        {
          value = y;
        }
        else
        {
          value = -y;
        }
        return value;
      }

      u = r4_uni_01 ( );

      if ( u <= ustar )
      {
        tt = u;
      }
      else
      {
        u = r4_uni_01 ( );
        w = u * d[i-1];
        tt = ( 0.5 * w + aa ) * w;
      }
    }
  }
}
/******************************************************************************/

float r4_uni_01 ( )
{
  int i;
  float value;
/*
  Check whether the package must be initialized.
*/
  if ( ! initialized_get ( ) )
  {
    printf ( "\n" );
    printf ( "R4_UNI_01 - Note:\n" );
    printf ( "  Initializing RNGLIB package.\n" );
    initialize ( );
  }
/*
  Get a random integer.
*/
  i = i4_uni ( );
/*
  Scale it to [0,1].
*/
  value = ( float ) ( i ) * 4.656613057E-10;

  return value;
}
/******************************************************************************/

int initialized_get ( )
{
  int i;
  int value;

  i = -1;
  initialized_memory ( i, &value );

  return value;
}
/******************************************************************************/

void initialize ( )
{
  int g;
  const int g_max = 32;
  int ig1;
  int ig2;
  int value;
/*
  Remember that we have called INITIALIZE().
*/
  initialized_set ( );
/*
  Initialize all generators to have FALSE antithetic value.
*/
  value = 0;
  for ( g = 0; g < g_max; g++ )
  {
    cgn_set ( g );
    antithetic_set ( value );
  }
/*
  Set the initial seeds.
*/
  ig1 = 1234567890;
  ig2 = 123456789;
  set_initial_seed ( ig1, ig2 );
/*
  Initialize the current generator index to 0.
*/
  g = 0;
  cgn_set ( g );

  printf ( "\n" );
  printf ( "INITIALIZE - Note:\n" );
  printf ( "  The RNGLIB package has been initialized.\n" );

  return;
}
/******************************************************************************/

int i4_uni ( )
{
  const int a1 = 40014;
  const int a2 = 40692;
  int cg1;
  int cg2;
  int g;
  int k;
  const int m1 = 2147483563;
  const int m2 = 2147483399;
  int value;
  int z;
/*
  Check whether the package must be initialized.
*/
  if ( ! initialized_get ( ) )
  {
    printf ( "\n" );
    printf ( "I4_UNI - Note:\n" );
    printf ( "  Initializing RNGLIB package.\n" );
    initialize ( );
  }
/*
  Get the current generator index.
*/
  g = cgn_get ( );
/*
  Retrieve the current seeds.
*/
  cg_get ( g, &cg1, &cg2 );
/*
  Update the seeds.
*/
  k = cg1 / 53668;
  cg1 = a1 * ( cg1 - k * 53668 ) - k * 12211;

  if ( cg1 < 0 )
  {
    cg1 = cg1 + m1;
  }

  k = cg2 / 52774;
  cg2 = a2 * ( cg2 - k * 52774 ) - k * 3791;

  if ( cg2 < 0 )
  {
    cg2 = cg2 + m2;
  }
/*
  Store the updated seeds.
*/
  cg_set ( g, cg1, cg2 );
/*
  Form the random integer.
*/
  z = cg1 - cg2;

  if ( z < 1 )
  {
    z = z + m1 - 1;
  }
/*
  If the generator is antithetic, reflect the value.
*/
  value = antithetic_get ( );

  if ( value )
  {
    z = m1 - z;
  }
  return z;
}
/******************************************************************************/

void initialized_memory ( int i, int *initialized )
{
  static int initialized_save = 0;

  if ( i < 0 )
  {
    *initialized = initialized_save;
  }
  else if ( i == 0 )
  {
    initialized_save = 0;
  }
  else if ( 0 < i )
  {
    initialized_save = *initialized;
  }

  return;
}
/******************************************************************************/

void initialized_set ( )
{
  int i;
  int initialized;

  i = +1;
  initialized = 1;
  initialized_memory ( i, &initialized );

  return;
}
/******************************************************************************/

void cgn_set ( int g )
{
  int i;

  i = +1;
  cgn_memory ( i, &g );

  return;
}
/******************************************************************************/

int cgn_get ( )
{
  int g;
  int i;

  i = -1;
  cgn_memory ( i, &g );

  return g;
}
/******************************************************************************/

void cgn_memory ( int i, int *g )
{
# define G_MAX 32

  static int g_save = 0;
  const int g_max = 32;
  int j;

  if ( i < 0 )
  {
    *g = g_save;
  }
  else if ( i == 0 )
  {
    g_save = 0;
    *g = g_save;
  }
  else if ( 0 < i )
  {

    if ( *g < 0 || g_max <= *g )
    {
      fprintf ( stderr, "\n" );
      fprintf ( stderr, "CGN_MEMORY - Fatal error!\n" );
      fprintf ( stderr, "  Input generator index G is out of bounds.\n" );
      exit ( 1 );
    }

    g_save = *g;
  }

  return;
# undef G_MAX
}
/******************************************************************************/

void cg_get ( int g, int *cg1, int *cg2 )
{
  int i;

  i = -1;
  cg_memory ( i, g, cg1, cg2 );

  return;
}
/******************************************************************************/

void cg_memory ( int i, int g, int *cg1, int *cg2 )
{
# define G_MAX 32

  static int cg1_save[G_MAX];
  static int cg2_save[G_MAX];
  const int g_max = 32;
  int j;

  if ( g < 0 || g_max <= g )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "CG_MEMORY - Fatal error!\n" );
    fprintf ( stderr, "  Input generator index G is out of bounds.\n" );
    exit ( 1 );
  }

  if ( i < 0 )
  {
    *cg1 = cg1_save[g];
    *cg2 = cg2_save[g];
  }
  else if ( i == 0 )
  {
    for ( j = 0; j < g_max; j++ )
    {
      cg1_save[j] = 0;
      cg2_save[j] = 0;
    }
  }
  else if ( 0 < i )
  {
    cg1_save[g] = *cg1;
    cg2_save[g] = *cg2;
  }

  return;
# undef G_MAX
}
/******************************************************************************/

void cg_set ( int g, int cg1, int cg2 )
{
  int i;

  i = +1;
  cg_memory ( i, g, &cg1, &cg2 );

  return;
}
/******************************************************************************/

int antithetic_get ( )
{
  int i;
  int value;

  i = -1;
  antithetic_memory ( i, &value );

  return value;
}
/******************************************************************************/

void antithetic_memory ( int i, int *value )
{
# define G_MAX 32

  static int a_save[G_MAX];
  int g;
  const int g_max = 32;
  int j;

  if ( i < 0 )
  {
    g = cgn_get ( );
    *value = a_save[g];
  }
  else if ( i == 0 )
  {
    for ( j = 0; j < g_max; j++ )
    {
      a_save[j] = 0;
    }
  }
  else if ( 0 < i )
  {
    g = cgn_get ( );
    a_save[g] = *value;
  }

  return;
# undef G_MAX
}
/******************************************************************************/

void antithetic_set ( int value )
{
  int i;

  i = +1;
  antithetic_memory ( i, &value );

  return;
}
/******************************************************************************/

void set_initial_seed ( int ig1, int ig2 )
{
  const int a1_vw = 2082007225;
  const int a2_vw = 784306273;
  int g;
  const int g_max = 32;
  int i;
  const int m1 = 2147483563;
  const int m2 = 2147483399;
  int t;

  if ( ig1 < 1 || m1 <= ig1 )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "SET_INITIAL_SEED - Fatal error!\n" );
    fprintf ( stderr, "  Input parameter IG1 out of bounds.\n" );
    exit ( 1 );
  }

  if ( ig2 < 1 || m2 <= ig2 )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "SET_INITIAL_SEED - Fatal error!\n" );
    fprintf ( stderr, "  Input parameter IG2 out of bounds.\n" );
    exit ( 1 );
  }
/*
  Because INITIALIZE calls SET_INITIAL_SEED, it's not easy to correct
  the error that arises if SET_INITIAL_SEED is called before INITIALIZE.
  So don't bother trying.
*/
  if ( ! initialized_get ( ) )
  {
    printf ( "\n" );
    printf ( "SET_INITIAL_SEED - Fatal error!\n" );
    printf ( "  The RNGLIB package has not been initialized.\n" );
    exit ( 1 );
  }
/*
  Set the initial seed, then initialize the first generator.
*/
  g = 0;
  cgn_set ( g );

  ig_set ( g, ig1, ig2 );

  t = 0;
  init_generator ( t );
/*
  Now do similar operations for the other generators.
*/
  for ( g = 1; g < g_max; g++ )
  {
    cgn_set ( g );
    ig1 = multmod ( a1_vw, ig1, m1 );
    ig2 = multmod ( a2_vw, ig2, m2 );
    ig_set ( g, ig1, ig2 );
    init_generator ( t );
  }
/*
  Now choose the first generator.
*/
  g = 0;
  cgn_set ( g );

  return;
}
/******************************************************************************/

void ig_get ( int g, int *ig1, int *ig2 )
{
  int i;

  i = -1;
  ig_memory ( i, g, ig1, ig2 );

  return;
}
/******************************************************************************/

void ig_memory ( int i, int g, int *ig1, int *ig2 )
{
# define G_MAX 32

  const int g_max = 32;
  static int ig1_save[G_MAX];
  static int ig2_save[G_MAX];
  int j;

  if ( g < 0 || g_max <= g )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "IG_MEMORY - Fatal error!\n" );
    fprintf ( stderr, "  Input generator index G is out of bounds.\n" );
    exit ( 1 );
  }

  if ( i < 0 )
  {
    *ig1 = ig1_save[g];
    *ig2 = ig2_save[g];
  }
  else if ( i == 0 )
  {
    for ( j = 0; j < g_max; j++ )
    {
      ig1_save[j] = 0;
      ig2_save[j] = 0;
    }
  }
  else if ( 0 < i )
  {
    ig1_save[g] = *ig1;
    ig2_save[g] = *ig2;
  }

  return;
# undef G_MAX
}
/******************************************************************************/

void ig_set ( int g, int ig1, int ig2 )
{
  int i;

  i = +1;
  ig_memory ( i, g, &ig1, &ig2 );

  return;
}
/******************************************************************************/

void init_generator ( int t )
{
  const int a1_w = 1033780774;
  const int a2_w = 1494757890;
  int cg1;
  int cg2;
  int g;
  int ig1;
  int ig2;
  int lg1;
  int lg2;
  const int m1 = 2147483563;
  const int m2 = 2147483399;
/*
  Check whether the package must be initialized.
*/
  if ( ! initialized_get ( ) )
  {
    printf ( "\n" );
    printf ( "INIT_GENERATOR - Note:\n" );
    printf ( "  Initializing RNGLIB package.\n" );
    initialize ( );
  }
/*
  Get the current generator index.
*/
  g = cgn_get ( );
/*
  0: restore the initial seed.
*/
  if ( t == 0 )
  {
    ig_get ( g, &ig1, &ig2 );
    lg1 = ig1;
    lg2 = ig2;
    lg_set ( g, lg1, lg2 );
  }
/*
  1: restore the last seed.
*/
  else if ( t == 1 )
  {
    lg_get ( g, &lg1, &lg2 );
  }
/*
  2: advance to a new seed.
*/
  else if ( t == 2 )
  {
    lg_get ( g, &lg1, &lg2 );
    lg1 = multmod ( a1_w, lg1, m1 );
    lg2 = multmod ( a2_w, lg2, m2 );
    lg_set ( g, lg1, lg2 );
  }
  else
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "INIT_GENERATOR - Fatal error!\n" );
    fprintf ( stderr, "  Input parameter T out of bounds.\n" );
    exit ( 1 );
  }
/*
  Store the new seed.
*/
  cg1 = lg1;
  cg2 = lg2;
  cg_set ( g, cg1, cg2 );

  return;
}
/******************************************************************************/

void lg_get ( int g, int *lg1, int *lg2 )
{
  int i;

  i = -1;
  lg_memory ( i, g, lg1, lg2 );

  return;
}
/******************************************************************************/

void lg_memory ( int i, int g, int *lg1, int *lg2 )
{
# define G_MAX 32

  const int g_max = 32;

  int j;
  static int lg1_save[G_MAX];
  static int lg2_save[G_MAX];

  if ( g < 0 || g_max <= g )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "LG_MEMORY - Fatal error!\n" );
    fprintf ( stderr, "  Input generator index G is out of bounds.\n" );
    exit ( 1 );
  }

  if ( i < 0 )
  {
    *lg1 = lg1_save[g];
    *lg2 = lg2_save[g];
  }
  else if ( i == 0 )
  {
    for ( j = 0; j < g_max; j++ )
    {
      lg1_save[j] = 0;
      lg2_save[j] = 0;
    }
  }
  else if ( 0 < i )
  {
    lg1_save[g] = *lg1;
    lg2_save[g] = *lg2;
  }
  return;
# undef G_MAX
}
/******************************************************************************/

void lg_set ( int g, int lg1, int lg2 )
{
  int i;

  i = +1;
  lg_memory ( i, g, &lg1, &lg2 );

  return;
}
/******************************************************************************/

int multmod ( int a, int s, int m )
{
  int a0;
  int a1;
  const int h = 32768;
  int k;
  int p;
  int q;
  int qh;
  int rh;

  if ( a <= 0 )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "MULTMOD - Fatal error!\n" );
    fprintf ( stderr, "  A <= 0.\n" );
    exit ( 1 );
  }

  if ( m <= a )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "MULTMOD - Fatal error!\n" );
    fprintf ( stderr, "  M <= A.\n" );
    exit ( 1 );
  }

  if ( s <= 0 )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "MULTMOD - Fatal error!\n" );
    fprintf ( stderr, "  S <= 0.\n" );
    exit ( 1 );
  }

  if ( m <= s )
  {
    fprintf ( stderr, "\n" );
    fprintf ( stderr, "MULTMOD - Fatal error!\n" );
    fprintf ( stderr, "  M <= S.\n" );
    exit ( 1 );
  }

  if ( a < h )
  {
    a0 = a;
    p = 0;
  }
  else
  {
    a1 = a / h;
    a0 = a - h * a1;
    qh = m / h;
    rh = m - h * qh;

    if ( h <= a1 )
    {
      a1 = a1 - h;
      k = s / qh;
      p = h * ( s - k * qh ) - k * rh;

      while ( p < 0 )
      {
        p = p + m;
      }
    }
    else
    {
      p = 0;
    }

    if ( a1 != 0 )
    {
      q = m / a1;
      k = s / q;
      p = p - k * ( m - a1 * q );

      if ( 0 < p )
      {
        p = p - m;
      }

      p = p + a1 * ( s - k * q );

      while ( p < 0 )
      {
        p = p + m;
      }
    }

    k = p / qh;
    p = h * ( p - k * qh ) - k * rh;

    while ( p < 0 )
    {
      p = p + m;
    }
  }

  if ( a0 != 0 )
  {
    q = m / a0;
    k = s / q;
    p = p - k * ( m - a0 * q );

    if ( 0 < p )
    {
      p = p - m;
    }

    p = p + a0 * ( s - k * q );

    while ( p < 0 )
    {
      p = p + m;
    }
  }
  return p;
}
/******************************************************************************/
